#include <windows.h>
#include <stdio.h>

/* X1 IRQ device numbers */
/*
	傫قǗD揇ʂB
	̔z͎茳ɖ̂œKɔzuĂB
	bsb͂P`bvS{gp
	rhn͂P`bvW{gp
*/
/* lower priority */
#define DEVICE_SUB  1
#define DEVICE_SIO0 2
#define DEVICE_CTC2 10
#define DEVICE_CTC1 14
#define DEVICE_CTC0 18
#define DEVICE_DMA  22
/* higher priority */

#define MAX_DAISY_CHAIN 22

/* for CPU interface */

/* before CPU execute, after (extra instruction of)EI, after RETN */
void __fastcall X1_check_irq_line(void);
/* after RETI */
void __fastcall X1_irq_reti(void);
/* for IRQ device */
void __fastcall X1_set_irq_line(BYTE device);
void __fastcall X1_clear_irq_line(BYTE device);
void __fastcall X1_clear_ieo_line(BYTE device);
BYTE __fastcall X1_check_pending_irq(BYTE device);
void __fastcall X1_set_irq_vector(BYTE device,BYTE vector);
void init_irq(void);
